
//	 General purpose routines for HCS08 processors
//
//  Copyright 2009 Filip Mulier
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

/* MODULE general */


/* Include shared modules, which are used for whole project */

#include "derivative.h"


signed char abs(signed char y);

signed char interpolate(byte x);








typedef short fixed;			// Our new fixed point type. 

fixed lowpass(fixed in,fixed instore,byte fparam, byte *lsb_store);
fixed fmul(fixed x,fixed y);
fixed fdiv(fixed x,fixed y);
fixed faddc(fixed x,fixed y);
fixed fmulc(fixed x, fixed y);
fixed farctan2(byte y, byte x);
fixed farctan2x10(byte y, byte x);
fixed farctan2fs(byte y, byte x);
fixed farctan2fsf(fixed y, fixed x);
fixed fsinfsf(fixed ang);
fixed fcosfsf(fixed ang);
fixed fdiv10(fixed a);
fixed fmul10(fixed a);

// Radix point is 8 bits in

#define btofx(x) ((fixed)(x) << 8)			// Byte or integer to fixed point
#define fxtob(x) ((x) >> 8)			// Fixed point to byte
#define fadd(x,y) ((x)+(y))     // Addition for fixed point
#define fsub(x,y) ((x)-(y))     // Subtraction for fixed point
#define faddi(x,i) ((x)+((fixed)(i)<<8))  //Addition of a fixed and a byte or integer
#define fsubi(x,i) ((x)-((fixed)(i)<<8))  //Subtraction of a fixed and a byte or integer
#define fmuli(x,i) ((x)*(fixed)(i))       //Multiplication of a fixed and a byte or integer
#define fdivi(x,i) ((x)/(fixed)(i))       //Division of a fixed and a byte or integer


//Arbitrary conversion of x from q1 to q2 format
#define fconv(x,q1,q2) (((q2)>(q1)) ? (x)<<((q2)-(q1)) : (x)>>((q1)-(q2)))

#define pi 3.1415927




void timedelay(unsigned char d);

void Delay(unsigned int d);

void ran0(long *idnum);




/* END general */


