/*
** ###################################################################
**     This code is generated by the Device Initialization Tool.
**     It is overwritten during code generation.
**     USER MODIFICATION ARE PRESERVED ONLY INSIDE INTERRUPT SERVICE ROUTINES
**     OR EXPLICITLY MARKED SECTIONS
**
**     Project     : DeviceInitialization
**     Processor   : MC9S08SG8CTG
**     Version     : Component 01.006, Driver 01.08, CPU db: 3.00.063
**     Datasheet   : MC9S08SG8 Rev. 3 12/2007
**     Date/Time   : 2014-06-01, 06:13, # CodeGen: 47
**     Abstract    :
**         This module contains device initialization code 
**         for selected on-chip peripherals.
**     Contents    :
**         Function "MCU_init" initializes selected peripherals
**
**     Copyright : 1997 - 2013 Freescale Semiconductor, Inc. All Rights Reserved.
**     SOURCE DISTRIBUTION PERMISSIBLE as directed in End User License Agreement.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################
*/

/* MODULE MCUinit */

#include <mc9s08sg8.h>                 /* I/O map for MC9S08SG8CTG */
#include "MCUinit.h"

/* Standard ANSI C types */
#ifndef int8_t
typedef signed char int8_t;
#endif
#ifndef int16_t
typedef signed int int16_t;
#endif
#ifndef int32_t
typedef signed long int int32_t;
#endif

#ifndef uint8_t
typedef unsigned char uint8_t;
#endif
#ifndef uint16_t
typedef unsigned int uint16_t;
#endif
#ifndef uint32_t
typedef unsigned long int uint32_t;
#endif

/* User declarations and definitions */
/*   Code, declarations and definitions here will be preserved during code generation */

extern volatile byte AD_ready_flag; //flag used to indicate Ato D is ready for user to read
extern volatile word ADvalue; //value of A to D channel read
extern volatile byte count;


void CycleAD(byte AD_chan)
	{
	AD_ready_flag=0;
	ADCSC1 = (AD_chan&31)| 64;		//select the channel and set AIEN
	}





/* End of user declarations and definitions */


/*
** ===================================================================
**     Method      :  Cpu_MCU_init (component MC9S08SG8_16)
*/
/*!
**     @brief
**         Device initialization code for selected peripherals.
*/
/* ===================================================================*/
void MCU_init(void)
{
  /* ### MC9S08SG8_16 "Cpu" init code ... */
  /*  PE initialization code after reset */
  /* Common initialization of the write once registers */
  /* SOPT1: COPT=0,STOPE=0,IICPS=0 */
  SOPT1 = 0x00U;                                   
  /* SOPT2: COPCLKS=0,COPW=0,ACIC=0,T1CH1PS=0,T1CH0PS=0 */
  SOPT2 = 0x00U;                                   
  /* SPMSC1: LVWF=0,LVWACK=0,LVWIE=0,LVDRE=1,LVDSE=1,LVDE=1,BGBE=1 */
  SPMSC1 = 0x1DU;                                   
  /* SPMSC2: LVDV=0,LVWV=0,PPDF=0,PPDACK=0,PPDC=0 */
  SPMSC2 = 0x00U;                                   
  /*  System clock initialization */
  /*lint -save  -e923 Disable MISRA rule (11.3) checking. */
  if (*(unsigned char*far)0xFFAFU != 0xFFU) { /* Test if the device trim value is stored on the specified address */
    ICSTRM = *(unsigned char*far)0xFFAFU; /* Initialize ICSTRM register from a non volatile memory */
    ICSSC = *(unsigned char*far)0xFFAEU; /* Initialize ICSSC register from a non volatile memory */
  }
  /*lint -restore Enable MISRA rule (11.3) checking. */
  /* ICSC1: CLKS=0,RDIV=0,IREFS=1,IRCLKEN=1,IREFSTEN=0 */
  ICSC1 = 0x06U;                       /* Initialization of the ICS control register 1 */
  /* ICSC2: BDIV=0,RANGE=0,HGO=0,LP=0,EREFS=0,ERCLKEN=0,EREFSTEN=0 */
  ICSC2 = 0x00U;                       /* Initialization of the ICS control register 2 */
  while(ICSSC_IREFST == 0U) {          /* Wait until the source of reference clock is internal clock */
  }
  /* GNGC: GNGPS7=0,GNGPS6=0,GNGPS5=0,GNGPS4=0,GNGPS3=0,GNGPS2=0,GNGPS1=0,GNGEN=0 */
  GNGC = 0x00U;                                   

  /* Common initialization of the CPU registers */
  /* PTAPE: PTAPE0=0 */
  PTAPE &= (unsigned char)~(unsigned char)0x01U;                     
  /* PTBPE: PTBPE7=1,PTBPE6=1,PTBPE5=0 */
  PTBPE = (PTBPE & (unsigned char)~(unsigned char)0x20U) | (unsigned char)0xC0U;
  /* PTASE: PTASE3=0,PTASE2=0,PTASE1=0,PTASE0=0 */
  PTASE &= (unsigned char)~(unsigned char)0x0FU;                     
  /* PTBSE: PTBSE7=0,PTBSE6=0,PTBSE5=0,PTBSE4=0,PTBSE3=0,PTBSE2=0,PTBSE1=0,PTBSE0=0 */
  PTBSE = 0x00U;                                   
  /* PTCSE: PTCSE0=0 */
  PTCSE &= (unsigned char)~(unsigned char)0x01U;                     
  /* PTADS: PTADS3=0,PTADS2=0,PTADS1=0,PTADS0=1 */
  PTADS = 0x01U;                                   
  /* PTBDS: PTBDS7=0,PTBDS6=0,PTBDS5=1,PTBDS4=0,PTBDS3=1,PTBDS2=0,PTBDS1=1,PTBDS0=0 */
  PTBDS = 0x2AU;                                   
  /* PTCDS: PTCDS3=0,PTCDS2=0,PTCDS1=0,PTCDS0=0 */
  PTCDS = 0x00U;                                   
  /* PTBDD: PTBDD7=0,PTBDD6=0 */
  PTBDD &= (unsigned char)~(unsigned char)0xC0U;                     
  /* PTCDD: PTCDD3=0,PTCDD2=0,PTCDD1=0 */
  PTCDD &= (unsigned char)~(unsigned char)0x0EU;                     
  /* PTCPE: PTCPE3=1,PTCPE2=1,PTCPE1=1 */
  PTCPE |= (unsigned char)0x0EU;                      
  /* ### Init_TPM init code */
  (void)(TPM1C0SC == 0U);              /* Channel 0 int. flag clearing (first part) */
  /* TPM1C0SC: CH0F=0,CH0IE=0,MS0B=1,MS0A=0,ELS0B=1,ELS0A=0 */
  TPM1C0SC = 0x28U;                    /* Int. flag clearing (2nd part) and channel 0 contr. register setting */
  TPM1C0V = 0x0200U;                   /* Compare 0 value setting */
  (void)(TPM1C1SC == 0U);              /* Channel 1 int. flag clearing (first part) */
  /* TPM1C1SC: CH1F=0,CH1IE=0,MS1B=1,MS1A=0,ELS1B=1,ELS1A=0 */
  TPM1C1SC = 0x28U;                    /* Int. flag clearing (2nd part) and channel 1 contr. register setting */
  TPM1C1V = 0x00U;                     /* Compare 1 value setting */
  /* TPM1SC: TOF=0,TOIE=0,CPWMS=0,CLKSB=0,CLKSA=0,PS2=0,PS1=0,PS0=0 */
  TPM1SC = 0x00U;                      /* Stop and reset counter */
  TPM1MOD = 0x0400U;                   /* Period value setting */
  (void)(TPM1SC == 0U);                /* Overflow int. flag clearing (first part) */
  /* TPM1SC: TOF=0,TOIE=0,CPWMS=0,CLKSB=0,CLKSA=1,PS2=0,PS1=0,PS0=0 */
  TPM1SC = 0x08U;                      /* Int. flag clearing (2nd part) and timer control register setting */
  /* ### Init_ADC init code */
  /* APCTL1: ADPC7=0,ADPC6=0,ADPC5=0,ADPC4=0,ADPC3=0,ADPC2=0,ADPC1=0,ADPC0=0 */
  APCTL1 = 0x00U;                                   
  /* ADCCFG: ADLPC=0,ADIV1=1,ADIV0=0,ADLSMP=0,MODE1=1,MODE0=0,ADICLK1=0,ADICLK0=0 */
  ADCCFG = 0x48U;                                   
  /* ADCCV: ADCV9=0,ADCV8=0,ADCV7=0,ADCV6=0,ADCV5=0,ADCV4=0,ADCV3=0,ADCV2=0,ADCV1=0,ADCV0=0 */
  ADCCV = 0x00U;                            
  /* ADCSC2: ADACT=0,ADTRG=0,ACFE=0,ACFGT=0 */
  ADCSC2 = 0x00U;                                   
  /* ADCSC1: COCO=0,AIEN=1,ADCO=0,ADCH4=0,ADCH3=0,ADCH2=0,ADCH1=0,ADCH0=1 */
  ADCSC1 = 0x41U;                                   
  /* ### Init_GPIO init code */
  /* PTBD: PTBD4=0,PTBD3=0,PTBD2=0,PTBD1=0,PTBD0=0 */
  PTBD &= (unsigned char)~(unsigned char)0x1FU;                     
  /* PTBPE: PTBPE4=1,PTBPE2=1 */
  PTBPE |= (unsigned char)0x14U;                      
  /* PTBDD: PTBDD4=0,PTBDD3=1,PTBDD2=0,PTBDD1=1,PTBDD0=1 */
  PTBDD = (PTBDD & (unsigned char)~(unsigned char)0x14U) | (unsigned char)0x0BU;
  /* ### Init_IIC init code */
  /* IICC2: GCAEN=0,ADEXT=0,AD10=0,AD9=0,AD8=0 */
  IICC2 = 0x00U;                                   
  /* IICA: AD7=0,AD6=0,AD5=0,AD4=0,AD3=0,AD2=0,AD1=0 */
  IICA = 0x00U;                                   
  /* IICF: MULT1=0,MULT0=0,ICR5=0,ICR4=0,ICR3=0,ICR2=0,ICR1=0,ICR0=0 */
  IICF = 0x00U;                                   
  /* IICS: TCF=1,IAAS=0,BUSY=0,ARBL=1,SRW=0,IICIF=1,RXAK=0 */
  IICS = 0x92U;                        /* Clear the interrupt flags */
  /* IICC1: IICEN=0,IICIE=0,MST=0,TX=0,TXAK=0,RSTA=0 */
  IICC1 = 0x00U;                                   
  /* ### Init_MTIM init code */
  /* MTIMMOD: MOD7=1,MOD6=1,MOD5=1,MOD4=1,MOD3=1,MOD2=1,MOD1=1,MOD0=1 */
  MTIMMOD = 0xFFU;                                   
  /* MTIMCLK: CLKS1=0,CLKS0=0,PS3=1,PS2=0,PS1=0,PS0=0 */
  MTIMCLK = 0x08U;                                   
  (void)(MTIMSC == 0U);                /* Overflow int. flag clearing (first part) */
  /* MTIMSC: TOF=0,TOIE=1,TRST=1,TSTP=0 */
  MTIMSC = 0x60U;                      /* Int. flag clearing (2nd part) and timer control register setting */
  /* ### */
  /*lint -save  -e950 Disable MISRA rule (1.1) checking. */
  asm CLI;                             /* Enable interrupts */
  /*lint -restore Enable MISRA rule (1.1) checking. */

} /*MCU_init*/


/*lint -save  -e765 Disable MISRA rule (8.10) checking. */
/*
** ===================================================================
**     Interrupt handler : isrVmtim
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void isrVmtim(void)
{
  /* Write your interrupt code here ... */
	(void)MTIMSC;		//read it																						 //
	MTIMSC_TOF = 0; //clear it	
	if(count>0)
	  count=count-1;


}
/* end of isrVmtim */


/*
** ===================================================================
**     Interrupt handler : isrViic
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void isrViic(void)
{
  /* Write your interrupt code here ... */

}
/* end of isrViic */


/*
** ===================================================================
**     Interrupt handler : isrVadc
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void isrVadc(void)
{
  /* Write your interrupt code here ... */
	//A to D cycle complete
	  ADvalue=ADCR; //value of A to D channel read	
	  AD_ready_flag=1;
	 	
}
/* end of isrVadc */


/*
** ===================================================================
**     Interrupt handler : isrVtpm1ovf
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void isrVtpm1ovf(void)
{
  /* Write your interrupt code here ... */

}
/* end of isrVtpm1ovf */


/*
** ===================================================================
**     Interrupt handler : isrVtpm1ch1
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void isrVtpm1ch1(void)
{
  /* Write your interrupt code here ... */

}
/* end of isrVtpm1ch1 */


/*
** ===================================================================
**     Interrupt handler : isrVtpm1ch0
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void isrVtpm1ch0(void)
{
  /* Write your interrupt code here ... */

}
/* end of isrVtpm1ch0 */


/*lint -restore Enable MISRA rule (8.10) checking. */

/*lint -save  -e950 Disable MISRA rule (1.1) checking. */
/* Initialization of the CPU registers in FLASH */
/* NVPROT: FPS7=1,FPS6=1,FPS5=1,FPS4=1,FPS3=1,FPS2=1,FPS1=1,FPDIS=1 */
static const unsigned char NVPROT_INIT @0x0000FFBDU = 0xFFU;
/* NVOPT: KEYEN=0,FNORED=1,SEC01=1,SEC00=0 */
static const unsigned char NVOPT_INIT @0x0000FFBFU = 0x7EU;
/*lint -restore Enable MISRA rule (1.1) checking. */



extern near void _Startup(void);

/* Interrupt vector table */
#ifndef UNASSIGNED_ISR
  #define UNASSIGNED_ISR ((void(*near const)(void)) 0xFFFF) /* unassigned interrupt service routine */
#endif

/*lint -save  -e923 Disable MISRA rule (11.3) checking. */
/*lint -save  -e950 Disable MISRA rule (1.1) checking. */
static void (* near const _vect[])(void) @0xFFC0 = { /* Interrupt vector table */
/*lint -restore Enable MISRA rule (1.1) checking. */
         UNASSIGNED_ISR,               /* Int.no. 31 VReserved31 (at FFC0)           Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 30 Vacmp (at FFC2)                 Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 29 VReserved29 (at FFC4)           Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 28 VReserved28 (at FFC6)           Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 27 VReserved27 (at FFC8)           Unassigned */
         isrVmtim,                     /* Int.no. 26 Vmtim (at FFCA)                 Used */
         UNASSIGNED_ISR,               /* Int.no. 25 Vrtc (at FFCC)                  Unassigned */
         isrViic,                      /* Int.no. 24 Viic (at FFCE)                  Used */
         isrVadc,                      /* Int.no. 23 Vadc (at FFD0)                  Used */
         UNASSIGNED_ISR,               /* Int.no. 22 VReserved22 (at FFD2)           Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 21 Vportb (at FFD4)                Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 20 Vporta (at FFD6)                Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 19 VReserved19 (at FFD8)           Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 18 Vscitx (at FFDA)                Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 17 Vscirx (at FFDC)                Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 16 Vscierr (at FFDE)               Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 15 Vspi (at FFE0)                  Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 14 Vtpm2ovf (at FFE2)              Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 13 Vtpm2ch1 (at FFE4)              Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 12 Vtpm2ch0 (at FFE6)              Unassigned */
         isrVtpm1ovf,                  /* Int.no. 11 Vtpm1ovf (at FFE8)              Used */
         UNASSIGNED_ISR,               /* Int.no. 10 VReserved10 (at FFEA)           Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  9 VReserved9 (at FFEC)            Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  8 VReserved8 (at FFEE)            Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  7 VReserved7 (at FFF0)            Unassigned */
         isrVtpm1ch1,                  /* Int.no.  6 Vtpm1ch1 (at FFF2)              Used */
         isrVtpm1ch0,                  /* Int.no.  5 Vtpm1ch0 (at FFF4)              Used */
         UNASSIGNED_ISR,               /* Int.no.  4 VReserved4 (at FFF6)            Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  3 Vlvd (at FFF8)                  Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  2 VReserved2 (at FFFA)            Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  1 Vswi (at FFFC)                  Unassigned */
         _Startup                      /* Int.no.  0 Vreset (at FFFE)                Reset vector */
};
/*lint -restore Enable MISRA rule (11.3) checking. */




/* END MCUinit */

/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.08]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
